function form_to_json(form){var form_data=form.serializeArray();var data={};for(var input in form_data){data[form_data[input].name]=form_data[input].value;}
return data;}
function vote(elem){if($(elem).hasClass("disabled")){return;}
var value=parseInt($(elem).attr("data-vote"));var form=$(elem).parents("form").first();var data=form_to_json(form);data['vote']=value;$.ajax({type:"POST",url:form.attr("action"),dataType:"json",data:data,success:function(response){form.replaceWith($(response.html));},error:function(jqXHR,textStatus,errorThrown){alert(jqXHR.responseText);}});}
function setup_vote(){$("div.container-xxl").on("click","a.vote",function(e){e.preventDefault();vote(this);});}
function chart(elem_id,data,default_props){function make_x_axis(){return d3.svg.axis().scale(x).orient("bottom").ticks(d3.time.days,1)}
function make_y_axis(){return d3.svg.axis().scale(y).orient("left").ticks(5)}
if(typeof default_props==="undefined"){default_props={};}
if(!data){return;}
var props={width:250,height:50};$.extend(props,default_props);var margin={top:0,right:0,bottom:0,left:0},width=props.width-margin.left-margin.right,height=props.height-margin.top-margin.bottom;var w=Math.floor(width/data.length);var format_in=d3.time.format("%Y-%m-%d");var format_out=d3.time.format("");var x=d3.time.scale().range([0,width]);var y=d3.scale.linear().range([height,0]);var xAxis=d3.svg.axis().scale(x).orient("bottom").tickSize(0,0).tickFormat(format_out).ticks(d3.time.days,1);var yAxis=d3.svg.axis().scale(y).orient("left").tickSize(0,0).ticks("").tickSubdivide(1);var area=d3.svg.area().x(function(d){return x(d.date);}).y(function(d){return y(d.count);});var svg=d3.select(elem_id).append("svg").attr("class","chart-data").attr("width",width+margin.left+margin.right).attr("height",height+margin.top+margin.bottom).append("g").attr("transform","translate("+margin.left+","+margin.top+")");data.forEach(function(d){if(typeof d.date==="string"){d.date=format_in.parse(d.date);}});x.domain(d3.extent(data,function(d){return d.date;}));y.domain([0,d3.max(data,function(d){return d.count;})]);svg.append("g").attr("class","grid").attr("Transform","translate(0, "+height+")").call(make_x_axis().tickSize(height,0,0).tickFormat(""))
svg.append("g").attr("class","grid").call(make_y_axis().tickSize(-width,0,0).tickFormat(""))
svg.append("g").attr("class","bars").selectAll("rect").data(data).enter().append("rect").attr("x",function(d){return x(d.date);}).attr("y",function(d){return y(d.count);}).attr("width",w).attr("height",function(d){return height-y(d.count);});svg.append("g").attr("class","x axis").attr("transform","translate(0,"+height+")").call(xAxis)
svg.append("g").attr("class","y axis").call(yAxis)}
function ajax_chart(url,elements,props){elements=$(elements);if(elements.data("chart_loading")||elements.find("img.ajaxloader").length==0){return;}
elements.data("chart_loading",true);if(elements.find("svg.chart-data")){elements.find("svg.chart-data").remove();}
return $.ajax({dataType:"json",url:url,success:function(data){elements.each(function(index,elem){chart($(this).get(0),data.evolution,props);});},error:function(jqXHR,textStatus,errorThrown){},complete:function(jqXHR,textStatus){elements.find("img.ajaxloader").remove();elements.removeData("chart_loading");}});}
function setup_tooltips(){$("body").tooltip({selector:'[data-bs-toggle="tooltip"]'});$("body").tooltip({selector:"a.disabled"}).on("click","a.disabled",function(e){e.preventDefault();});}
function setup_flash_messages(){$('.flashmsgs .alert.alert-success').delay(3000).fadeOut('slow');}
function setup_back_to_top_link(offset,duration){duration=(typeof duration!=='undefined'?duration:250);$(window).scroll(function(){var button=$(".back-to-top");if($(this).scrollTop()>offset&&button.is(":hidden")){$(".back-to-top").stop().fadeIn(duration);}else if($(this).scrollTop()<=offset&&button.is(":visible")){$(".back-to-top").stop().fadeOut(duration);}});$(".back-to-top").click(function(e){e.preventDefault();$("html").animate({scrollTop:0},duration);})}
function setup_send_as(){$("div.container-xxl").on("click",".send-as-default",function(e){e.preventDefault();var select=$(this).next();$(this).hide();select.show();});}
function setup_expander(){$('span.expander').expander({slicePoint:500,userCollapseText:'\n[View Less]',expandText:'\n[View More]',beforeExpand:function(){$(this).removeClass("collapsed");$(this).addClass("expanded");},onCollapse:function(){$(this).removeClass("expanded");$(this).addClass("collapsed");}});}
function setup_keyboard_shortcuts(){Mousetrap.bind('?',function(){$("#keyboard-shortcuts").modal('toggle');});}
$(document).ready(function(){setup_vote();setup_tooltips();setup_flash_messages();setup_emails_list();setup_send_as();setup_expander();setup_fixed_font();setup_keyboard_shortcuts();});;